' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/02/24 
'
' FV-FIO01 Sample Program
' -----------------------------------------------------------------
Public Class FormMain
    Private Const MAX_DIO_BIT As Integer = 32
    Private Const HALF_DIO_BIT As Integer = 16

    Private m_dio As FVIL.Dio.CFviDioFIO01 = New FVIL.Dio.CFviDioFIO01
    Private m_thread As Threading.Thread

    'Rg[̔z
    Private m_di() As System.Windows.Forms.Label = New System.Windows.Forms.Label(HALF_DIO_BIT - 1) {}
    Private m_do() As System.Windows.Forms.Label = New System.Windows.Forms.Label(HALF_DIO_BIT - 1) {}

    Private m_flgOpen As Boolean = False                                                            'foCX̃I[v
    Private intErr As Integer                                                                       'G[ԍi[ϐ

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'Rg[̔z
        Dim str As String
        For i As Integer = 0 To (HALF_DIO_BIT - 1)
            str = "_labelDI" + i.ToString("00")
            m_di(i) = Me.GetType.GetField(str, Reflection.BindingFlags.Public Or Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance Or Reflection.BindingFlags.Static).GetValue(Me)
            str = "_labelDO" + i.ToString("00")
            m_do(i) = Me.GetType.GetField(str, Reflection.BindingFlags.Public Or Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance Or Reflection.BindingFlags.Static).GetValue(Me)
        Next

        'DO{^CLICKCxgǉ
        For Each lb As Label In m_do
            AddHandler lb.Click, AddressOf ButtonDO_Click
        Next
        Me.Show()

        'foCXID擾
        Dim form_open As New FormOpen
        If (form_open.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                'foCXI[v
                m_dio.Open(form_open.m_id)
                m_flgOpen = True

                'Ԃ̎擾
                '̓|[g̓ǂݏo
                Dim bitarray As System.Collections.BitArray = m_dio.Read()
                If (bitarray.Count = MAX_DIO_BIT) Then
                    For i As Integer = 0 To (HALF_DIO_BIT - 1)
                        If (bitarray(i) = True) Then
                            m_di(i).BackColor = Color.FromArgb(255, 128, 255)   '(0xFF, 0x80, 0xFF)
                            m_di(i).Text = "ON"
                        Else
                            m_di(i).BackColor = Color.Gray                      '(0x80, 0x80, 0x80)
                            m_di(i).Text = "OFF"
                        End If
                    Next
                End If
                'o̓f[^̎擾
                bitarray = m_dio.GetWrite
                If (bitarray.Count = MAX_DIO_BIT) Then
                    For i As Integer = 0 To (HALF_DIO_BIT - 1)
                        If (bitarray(i) = True) Then
                            m_do(i).BackColor = Color.Aqua                      '(0x00, 0xFF, 0xFF)
                            m_do(i).Text = "ON"
                        Else
                            m_do(i).BackColor = Color.Gray                      '(0x80, 0x80, 0x80)
                            m_do(i).Text = "OFF"
                        End If
                    Next
                End If

                '荞݃GbWɐ̎擾
                If (m_dio.InterruptEdge = FVIL.Dio.InterruptEdge.Fall) Then
                    ComboBoxInterruptEdge.SelectedIndex = 0
                Else
                    ComboBoxInterruptEdge.SelectedIndex = 1
                End If

                'Read^C}[̃X^[g
                Timer1.Start()

                m_dio.Timeout = -1
            Catch ex As Exception
                'G[
                intErr = m_dio.ErrorCode
                MessageBox.Show("ErrorCode : " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                If (m_flgOpen = False) Then
                    Me.Close()  'foCXI[vłȂꍇ̓TvvO̓I
                    Exit Sub
                End If
            End Try
        Else
            Me.Close()  'OKȂꍇ̓TvvO̓I
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' DO{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' DO{^CLICKCxgB
    ''' </remarks>
    Private Sub ButtonDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim bit As UInteger = 4294967295        '0xFFFFFFFF
        For i As UInteger = 0 To (m_do.Length - 1)
            If (m_do(i).Name = sender.Name) Then
                bit = i
                Exit For
            End If
        Next
        If (bit <> 4294967295) Then             '0xFFFFFFFF
            Dim now_data = m_dio.GetWriteBit(bit)
            m_dio.WriteBit(bit, Not (now_data))
            If (bit >= MAX_DIO_BIT) Then
                Exit Sub
            End If
            If (Not (now_data)) Then
                m_do(bit).BackColor = Color.Aqua        '(0x00, 0xFF, 0xFF)
                m_do(bit).Text = "ON"
            Else
                m_do(bit).BackColor = Color.Gray        '(0x80, 0x80, 0x80)
                m_do(bit).Text = "OFF"
            End If
        End If

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMain_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Enabled = False
        If (m_flgOpen = True) Then
            m_dio.Abort()
            Threading.Thread.Sleep(200)
        End If

    End Sub

    ''' <summary>
    ''' Read^C}[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ^C}[œ̓|[g̓ǂݏoB
    ''' </remarks>
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim bitarray As System.Collections.BitArray = m_dio.Read()
        If (bitarray.Count = MAX_DIO_BIT) Then
            For i As Integer = 0 To (HALF_DIO_BIT - 1)
                If (bitarray(i) = True) Then
                    m_di(i).BackColor = Color.FromArgb(255, 128, 255)       '(0xFF, 0x80, 0xFF)
                    m_di(i).Text = "ON"
                Else
                    m_di(i).BackColor = Color.Gray                          '(0x80, 0x80, 0x80)
                    m_di(i).Text = "OFF"
                End If
            Next
        End If

    End Sub

    ''' <summary>
    ''' Xbh
    ''' </summary>
    ''' <remarks>
    ''' 荞݂Inputl\B
    ''' </remarks>
    Private Sub IntThreadRun()
        Dim bitarray As System.Collections.BitArray
        Dim dele As New DeleSetIntText(AddressOf SetIntText)
        Dim data As UInteger
        Dim one As UInteger = 1

        Do
            Try
                data = 0
                bitarray = m_dio.ReadInterrupt()
                For i As Integer = 0 To (HALF_DIO_BIT - 1)
                    If (m_dio.ReadBit(i) = True) Then
                        data = data Or (one << i)
                    End If
                Next
                Me.Invoke(dele, data, Color.FromArgb(255, 128, 255))     '(0xFF, 0x80, 0xFF)
                Threading.Thread.Sleep(200)
                Me.Invoke(dele, data, Color.Silver)                      '(0xC0, 0xC0, 0xC0)
            Catch ex As Exception
                'G[
                intErr = m_dio.ErrorCode
                If (intErr <> FVIL.Dio.ErrorCode.ABORT) Then
                    MessageBox.Show("ErrorCode : " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
                Exit Do
            End Try
        Loop

    End Sub

    ''' <summary>
    ''' 荞݊Ď`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Xbhɂ銄荞݊ĎB
    ''' </remarks>
    Private Sub CheckBoxCheckInterrupt_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxCheckInterrupt.CheckedChanged
        If (CheckBoxCheckInterrupt.Checked = True) Then
            ComboBoxInterruptEdge.Enabled = False
            'Xbh
            m_thread = New Threading.Thread(AddressOf IntThreadRun)
            m_thread.Start()
        Else
            m_dio.Abort()
            ComboBoxInterruptEdge.Enabled = True
        End If

    End Sub

    ''' <summary>
    ''' fQ[g
    ''' </summary>
    ''' <remarks>
    ''' XbhŃeLXg{bNXύXB
    ''' </remarks>
    Delegate Sub DeleSetIntText(ByVal int_di As UInteger, ByVal color As System.Drawing.Color)
    Private Sub SetIntText(ByVal int_di As UInteger, ByVal color As System.Drawing.Color)
        TextBoxInterrupt.Text = "0x" + int_di.ToString("X8")
        TextBoxInterrupt.BackColor = color

    End Sub

    ''' <summary>
    ''' 荞݃GbWɐR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 荞ݐM̃GbWɐ̐ݒ菈B
    ''' </remarks>
    Private Sub ComboBoxInterruptEdge_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxInterruptEdge.SelectionChangeCommitted
        Try
            If (ComboBoxInterruptEdge.SelectedIndex = 0) Then
                m_dio.InterruptEdge = FVIL.Dio.InterruptEdge.Fall
            Else
                m_dio.InterruptEdge = FVIL.Dio.InterruptEdge.Rise
            End If
        Catch ex As Exception
            'G[
            intErr = m_dio.ErrorCode
            MessageBox.Show("ErrorCode : " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

End Class
